Crypto++ 8.5 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
VMAC_Base Class Referenceabstract

VMAC message authentication code base class. More...

Inheritance diagram for VMAC_Base:

## Public Member Functions
std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
void | Resynchronize (const byte *nonce, int length=-1)
| Resynchronize with an IV. More...
void | GetNextIV (RandomNumberGenerator &rng, byte *IV)
| Retrieves a secure IV for the next message. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
void | UncheckedSetKey (const byte *userKey, unsigned int keylength, const NameValuePairs &params)
| Sets the key for this object without performing parameter validation. More...
void | TruncatedFinal (byte *mac, size_t size)
| Computes the hash of the current message. More...
unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
ByteOrder | GetByteOrder () const
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
Public Member Functions inherited from IteratedHashBase< word64, MessageAuthenticationCode >
| IteratedHashBase ()
| Construct an IteratedHashBase.
unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
byte * | CreateUpdateSpace (size_t &size)
| Requests space which can be written into by the caller. More...
void | Restart ()
| Restart the hash. More...
void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length. More...
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length. More...
virtual size_t | DefaultKeyLength () const =0
| Returns default key length. More...
virtual size_t | GetValidKeyLength (size_t keylength) const =0
| Returns a valid key length for the algorithm. More...
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Additional Inherited Members
Public Types inherited from IteratedHashBase< word64, MessageAuthenticationCode >
typedef word64 | HashWordType
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

VMAC message authentication code base class.

Since
  Crypto++ 5.5

Definition at line 24 of file vmac.h.

## Member Function Documentation

## ◆ AlgorithmName()

std::string VMAC_Base::AlgorithmName | ( |  | ) | const
| inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like `AES` or `AES/GCM`. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  AlgorithmName is not universally implemented yet.

Reimplemented from Algorithm.

Definition at line 27 of file vmac.h.

## ◆ AlgorithmProvider()

std::string VMAC_Base::AlgorithmProvider | ( |  | ) | const
| inline virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Since
  Crypto++ 8.0

Reimplemented from Algorithm.

Definition at line 28 of file vmac.h.

## ◆ IVSize()

unsigned int VMAC_Base::IVSize | ( |  | ) | const
| inline virtual

Returns length of the IV accepted by this object.

Returns
  the size of an IV, in bytes

Exceptions

  NotImplemented() | if the object does not support resynchronization

The default implementation throws NotImplemented

Reimplemented from SimpleKeyingInterface.

Definition at line 29 of file vmac.h.

## ◆ MinIVLength()

unsigned int VMAC_Base::MinIVLength | ( |  | ) | const
| inline virtual

Provides the minimum size of an IV.

Returns
  minimal length of IVs accepted by this object, in bytes

Exceptions

  NotImplemented() | if the object does not support resynchronization

Reimplemented from SimpleKeyingInterface.

Definition at line 30 of file vmac.h.

## ◆ Resynchronize()

void VMAC_Base::Resynchronize | ( | const byte * | iv,
|  | int | ivLength = `-1`
| ) |  |
| virtual

Resynchronize with an IV.

Parameters

  iv | the initialization vector
  ivLength | the size of the initialization vector, in bytes

Resynchronize() resynchronizes with an IV provided by the caller. `ivLength=-1` means use IVSize().

Exceptions

  NotImplemented() | if the object does not support resynchronization

Reimplemented from SimpleKeyingInterface.

Definition at line 128 of file vmac.cpp.

## ◆ GetNextIV()

void VMAC_Base::GetNextIV | ( | RandomNumberGenerator & | rng,
|  | byte * | iv
| ) |  |
| virtual

Retrieves a secure IV for the next message.

Parameters

  rng | a RandomNumberGenerator to produce keying material
  iv | a block of bytes to receive the IV

The IV must be at least IVSize() in length.

This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize(). before using this object again.

Internally, the base class implementation calls RandomNumberGenerator's GenerateBlock()

Note
  This method is not implemented on decryption objects.

Reimplemented from SimpleKeyingInterface.

Definition at line 122 of file vmac.cpp.

## ◆ DigestSize()

unsigned int VMAC_Base::DigestSize | ( |  | ) | const
| inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 33 of file vmac.h.

## ◆ UncheckedSetKey()

void VMAC_Base::UncheckedSetKey | ( | const byte * | key,
|  | unsigned int | length,
|  | const NameValuePairs & | params
| ) |  |
| virtual

Sets the key for this object without performing parameter validation.

Parameters

  key | a byte buffer used to key the cipher
  length | the length of the byte buffer
  params | additional parameters passed as NameValuePairs

key must be at least DEFAULT_KEYLENGTH in length.

Implements SimpleKeyingInterface.

Definition at line 63 of file vmac.cpp.

## ◆ TruncatedFinal()

void VMAC_Base::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |
| virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() call Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  `COUNTOF(digest) <= DigestSize()` or `COUNTOF(digest) <= HASH::DIGESTSIZE` ensures the output byte buffer is a valid size.

Implements HashTransformation.

Definition at line 839 of file vmac.cpp.

## ◆ BlockSize()

unsigned int VMAC_Base::BlockSize | ( |  | ) | const
| inline virtual

Provides the block size of the compression function.

Returns
  block size of the compression function, in bytes

BlockSize() will return 0 if the hash is not block based or does not have an equivalent block size. For example, Keccak and SHA-3 do not have a block size, but they do have an equivalent block size called rate expressed as `r`.

Reimplemented from HashTransformation.

Definition at line 36 of file vmac.h.

## ◆ OptimalDataAlignment()

unsigned int VMAC_Base::OptimalDataAlignment | ( |  | ) | const
| virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

See also
  GetAlignment() and OptimalBlockSize()

Reimplemented from HashTransformation.

Definition at line 169 of file vmac.cpp.

The documentation for this class was generated from the following files:

- vmac.h
- vmac.cpp